
#include "histodet/histogramAbstract.hpp"

/*
 * Methods are not virtual because inherited classes should be used as template and methods inlined
 */

namespace histodet {


HistogramAbstract::HistogramAbstract(int hist_size, BucketerAbstract *bucketer):
	bucketer(bucketer), hist_size(hist_size),
	win_size(0), hist(hist_size)
{}

HistogramAbstract::~HistogramAbstract()
{}

void HistogramAbstract::loadImage(cv::Mat const &image, int window_size)
{
	setWinSize(window_size);
	img = bucketer->convertImage(image);
	first_line = first_col = true;
	if (img.rows < win_size || img.cols < win_size)
	{
		finished = true;
		cur_x = cur_y = -1;
	} else
	{
		finished = false;
		cur_x = cur_y = win_hsize;
	}
}


} // namespace histodet


