
#include <fstream>
#include "histodet/labelReader.hpp"

namespace histodet {

bool LabelReader::loadBoundingBox(std::string filename, cv::Rect &rect, int &status, int &quality)
{
	std::ifstream file;
	file.open(filename.c_str());
	if (!file.is_open()) return false;

	cv::Rect_<double> rectd;
	file >> rectd.x >> rectd.y >> rectd.width >> rectd.height;
	file >> status >> quality;
	file.close();

	if (integer)
	{
		rect.x = std::floor(rectd.x);
		rect.y = std::floor(rectd.y);
		rect.width = std::ceil(rectd.x+rectd.width) - rect.x;
		rect.height = std::ceil(rectd.y+rectd.height) - rect.y;
	} else
		rect = rectd;

	return true;
}


bool LabelReader::loadSizeOri(std::string filename, double &size, double &ori, double &center_x, double &center_y)
{
	std::ifstream file;
	file.open(filename.c_str());
	if (!file.is_open()) return false;

	file >> size >> ori;
	file >> center_x >> center_y;
	file.close();

	return true;
}


bool LabelReader::loadBlobs(std::string filename, std::vector<std::pair<double,double> > &blobs)
{
	std::ifstream file;
	file.open(filename.c_str());
	if (!file.is_open()) return false;

	int nblobs;
	file >> nblobs;
	blobs.resize(nblobs);
	for(int i = 0; i < nblobs; ++i) file >> blobs[i].first >> blobs[i].second;
	file.close();

	return true;
}


} // namespace histodet


